%define anolis_release .0.1
%global         repo dde-kwin

Name:           dde-kwin
Version:        5.5.24
Release:        2%{anolis_release}%{?dist}
Summary:        KWin configuration for Deepin Desktop Environment
License:        GPLv3+
URL:            https://github.com/linuxdeepin/%{name}
Source0:        %{url}/archive/%{version}/%{name}-%{version}.tar.gz
Patch0:         0001-dde-kwin-support-QFont.patch
Patch1:         0002-feat-close-judge-XDG_SESSION_TYPE.patch

BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  gdb
BuildRequires:  kwin-devel
BuildRequires:  pkgconfig(Qt5X11Extras)
BuildRequires:  pkgconfig(Qt5Qml)
BuildRequires:  gsettings-qt-devel
BuildRequires:  libepoxy-devel
BuildRequires:  dtkcore-devel
BuildRequires:  dtkgui-devel
BuildRequires:  kf5-kwayland-devel
BuildRequires:  kf5-kglobalaccel-devel
BuildRequires:  kf5-kdeclarative-devel
BuildRequires:  kf5-kservice-devel
BuildRequires:  kf5-plasma-devel
BuildRequires:  kdecoration-devel
BuildRequires:  kf5-ktextwidgets-devel

BuildRequires:  cmake(KDecoration2)
BuildRequires:  qt5-linguist
# for libQt5EdidSupport.a
BuildRequires:  qt5-qtbase-static
BuildRequires:  qt5-qtbase-private-devel
BuildRequires:  qt5-qtdeclarative-devel
BuildRequires:  dtkgui-devel
BuildRequires:  kf5-ki18n-devel
%{?_qt5:Requires: %{_qt5}%{?_isa} = %{_qt5_version}}
Requires:       dde-qt5integration%{?_isa}
#Requires:       kwin%%{?_isa} >= 5.17
Requires:       kwin%{?_isa} >= 5.15
# since F31
Obsoletes:      deepin-wm <= 1.9.38
Obsoletes:      deepin-wm-switcher <= 1.1.9
Obsoletes:      deepin-metacity <= 3.22.24
Obsoletes:      deepin-metacity-devel <= 3.22.24
Obsoletes:      deepin-mutter <= 3.20.38
Obsoletes:      deepin-mutter-devel <= 3.20.38

Requires:       kf5-kconfig-core
Requires:       kf5-kcoreaddons
Requires:       kf5-kglobalaccel-libs
Requires:       kf5-ki18n
Requires:       kf5-kwindowsystem
Requires:       kdecoration

%description
This package provides a kwin configuration that used as the new WM for Deepin
Desktop Environment.

%package devel
Summary:        Development package for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       kwin-devel%{?_isa}
Requires:       qt5-qtx11extras-devel%{?_isa}
Requires:       gsettings-qt-devel%{?_isa}
Requires:       dtkcore-devel%{?_isa}
Requires:       kf5-kglobalaccel-devel%{?_isa}
Requires:       deepin-desktop-server


%description devel
Header files and libraries for %{sname}.

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1
%patch1 -p1
sed -i 's:/lib:/%{_lib}:' plugins/platforms/lib/CMakeLists.txt
sed -i 's:/usr/lib:%{_libdir}:' plugins/platforms/plugin/main.cpp \
                                plugins/platforms/plugin/main_wayland.cpp
sed -i 's:/usr/lib:%{_libexecdir}:' deepin-wm-dbus/deepinwmfaker.cpp

%build
# help find (and prefer) qt5 utilities, e.g. qmake, lrelease
export PATH=%{_qt5_bindir}:$PATH
%cmake -DCMAKE_INSTALL_PREFIX=%{_prefix} \
       -DCMAKE_BUILD_TYPE=Release \
       -DUSE_WINDOW_TOOL=OFF \
       -DKWIN_VERSION=$(rpm -q --qf '%%{version}' kwin-devel) .
%make_build

%install
%make_install INSTALL_ROOT=%{buildroot}
chmod 755 %{buildroot}%{_bindir}/kwin_no_scale
install rpm/dde-kwin.postinst  %{buildroot}%{_datadir}/kwin/scripts/
chmod 755 %{buildroot}%{_datadir}/kwin/scripts/dde-kwin.postinst

%post
bash %{_datadir}/kwin/scripts/dde-kwin.postinst ||:

%ldconfig_scriptlets

%files
%doc CHANGELOG.md
%license LICENSE
%{_sysconfdir}/xdg/*
%{_bindir}/deepin-wm-dbus
%{_bindir}/kwin_no_scale
%{_libdir}/libkwin-xcb.so.*
%{_qt5_plugindir}/org.kde.kdecoration2/libdeepin-chameleon.so
%{_qt5_plugindir}/platforms/lib%{name}-xcb.so
%{_qt5_plugindir}/platforms/libdde-kwin-wayland.so
%{_qt5_plugindir}/kwin/effects/plugins/
%{_datadir}/dde-kwin-xcb/
#%%{_datadir}/applications/kwin-wm-multitaskingview.desktop
%{_datadir}/dbus-1/services/*.service
%{_datadir}/dbus-1/interfaces/*.xml
%{_datadir}/kwin/scripts/*
%{_datadir}/kwin/tabbox/*
%{_datadir}/dsg/


%files devel
%{_libdir}/libkwin-xcb.so
%{_libdir}/pkgconfig/%{name}.pc
%{_includedir}/%{name}

%changelog
* Wed Sep 20 2023 yangxianzhao <yangxianzhao@uniontech.com> - 5.5.24-2.0.1
- rebuild for qt5-qtbase-5.15.3

* Wed Feb 08 2023 liweiganga <liweiganga@uniontech.com> - 5.5.24-2
- feat: close judge wayland

* Fri Jan 06 2023 liweiganga <liweiganga@uniontech.com> - 5.5.24-1
- update: update to 5.5.24

* Mon Oct 10 2022 herengui <herengui@uniontech.com> - 5.3.19-1.03
- spec: remove debug mode for %%post scriptlet

* Mon Jun 13 2022 uoser <uoser@uniontech.com> - 5.3.19-1.02
- update: update to 5.3.19-1.02
